
#include <windows.h>

#include <stdio.h>
#include <stdlib.h>
#include <GL/gl.h>
#include <GL/glut.h>

#include "GLMetaseq.h"		// ^ZRCA[_

MQO_MODEL g_mqoModel;		// MQOf


// ̐ݒs֐
void mySetLight( void )
{
	GLfloat light_diffuse[]  = { 0.9, 0.9, 0.9, 1.0 };	// gUˌ
	GLfloat light_specular[] = { 1.0, 1.0, 1.0, 1.0 };	// ʔˌ
	GLfloat light_ambient[]  = { 0.3, 0.3, 0.3, 0.1 };	// 
	GLfloat light_position[] = { 0.0, 0.0, 0.0, 1.0 };	// ʒuƎ

	// ̐ݒ
	glLightfv( GL_LIGHT0, GL_DIFFUSE,  light_diffuse );	 // gUˌ̐ݒ
	glLightfv( GL_LIGHT0, GL_SPECULAR, light_specular ); // ʔˌ̐ݒ
	glLightfv( GL_LIGHT0, GL_AMBIENT,  light_ambient );	 // ̐ݒ
	glLightfv( GL_LIGHT0, GL_POSITION, light_position ); // ʒuƎނ̐ݒ

	glShadeModel( GL_SMOOTH );	// VF[fBO̎ނ̐ݒ
	glEnable( GL_LIGHT0 );		// ̗L
}


// `֐
void Draw( void )
{
	static GLfloat rot = 0.0;

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// 
	glClearColor(0.f, 0.f, 0.2f, 1.0);					// wiF
	glMatrixMode(GL_MODELVIEW);

	glEnable( GL_DEPTH_TEST );		// Bʏ̓Kp
	mySetLight();					// ̐ݒ
	glEnable( GL_LIGHTING );		// ON

	glPushMatrix();
		glTranslatef(0.0, -100.0, -400.0);	// sړ
		glRotatef(rot, 0.0, 1.0, 0.0);		// ]
		mqoCallModel(g_mqoModel);			// MQOf̃R[
	glPopMatrix();

	glDisable( GL_LIGHTING );
	glDisable( GL_DEPTH_TEST );

	glutSwapBuffers();

	rot += 1.0;
}


// EBhEό`ɌĂ΂֐
void Reshape (int w, int h)
{
	double	znear = 10;
	double	fovy = 50;
	double	zfar = 10000;

	// r[|[gݒ
	glViewport(0, 0, w, h);

	// ˉeݒ
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(fovy, (double)w/h, znear, zfar);
}


// L[Cxg֐
void Keyboard(unsigned char key, int x, int y)
{
	// 'q'L[I
	if ( key == 'q' ) {
		mqoDeleteModel( g_mqoModel );	// f̍폜
		mqoCleanup();					// GLMetaseq̏I
		exit(0);						// vȌI
	}
}


int main(int argc, char *argv[])
{
	// 
	glutInit(&argc,argv);										// OpenGL
	glutInitWindowPosition(100, 50);							// EBhE̕\ʒu
	glutInitWindowSize(640, 480);								// EBhẼTCY
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);	// fBXvCݒ
	glutCreateWindow("MQO Loader for OpenGL");					// EBhE̐

	// f\鏀
	mqoInit();											// GLMetaseq̏
	g_mqoModel = mqoCreateModel("ninja.mqo",1.0);		// f̃[h

	// R[obN֐̐ݒ
	glutDisplayFunc(Draw);			// `揈s֐
	glutIdleFunc(Draw);				// ACh̏s֐
	glutReshapeFunc(Reshape);		// EBhEό`̏s֐
	glutKeyboardFunc(Keyboard);		// L[͎̏s֐

	// Cxg҂̖[vɓ
	printf("'q'L[ŏI܂\n");
	glutMainLoop();

	return 0;
}
